## Search for promotions

### cURL

```
curl --request POST \
  --url https://api.fabric.inc/v3/promotions/search \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --header 'x-fabric-tenant-id: <x-fabric-tenant-id>' \
  --data '
{
  "size": 10,
  "offset": 0,
  "filters": [
    {
      "field": "name",
      "value": "Summer",
      "operator": "EQUAL"
    }
  ]
}
'
```

### Python

```
import requests

url = "https://api.fabric.inc/v3/promotions/search"

payload = {
    "size": 10,
    "offset": 0,
    "filters": [
        {
            "field": "name",
            "value": "Summer",
            "operator": "EQUAL"
        }
    ]
}
headers = {
    "x-fabric-tenant-id": "<x-fabric-tenant-id>",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
```

### JavaScript

```
const options = {
  method: 'POST',
  headers: {
    'x-fabric-tenant-id': '<x-fabric-tenant-id>',
    Authorization: 'Bearer <token>',
    'Content-Type': 'application/json'
  },
  body: JSON.stringify({
    size: 10,
    offset: 0,
    filters: [{field: 'name', value: 'Summer', operator: 'EQUAL'}]
  })
};

fetch('https://api.fabric.inc/v3/promotions/search', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));
```

### PHP

```


```

### Response Codes

- **200 OK** 
- **400 Bad Request** 
- **401 Unauthorized** 
- **500 Internal Server Error**

### Example Response

```
{
  "query": {
    "size": 10,
    "offset": 10,
    "count": 50
  },
  "data": [
    {
      "id": "abcdefg1ee7ce20123456789",
      "couponCodes": [
        "SUMMER100",
        "SUMMER20"
      ],
      "couponCodesCount": 0,
      "status": "SCHEDULED",
      "name": "CREATE PROMO",
      "startAt": "2019-08-24T14:15:22.000Z",
      "endAt": "2019-08-25T14:15:22.000Z",
      "updatedAt": "2019-08-20T14:15:22.000Z",
      "singleMultiUse": "MULTI_USE",
      "type": "PRODUCT",
      "level": 1,
      "stackingType": "STACKABLE",
      "isStackable": true,
      "isAlwaysApplied": false,
      "additionalAttributes": [
        {
          "name": "type",
          "values": "Birthday",
          "attributeId": 100000
        }
      ],
      "promotionMessages": [
        {
          "title": "Buy 2 get 1 free",
          "message": "Offer valid at participating stores through September 5, 2023.",
          "pages": [
            "PDP",
            "Cart"
          ],
          "locales": [
            "en-CA",
            "fr-CA"
          ]
        }
      ],
      "proximityMessages": {
        "threshold": 1,
        "localizedMessages": [
          {
            "locales": [
              "en-CA"
            ],
            "message": "Buy some more to get the discount!"
          }
        ]
      }
    }
  ]
}
```

### Error Responses

#### 400 Bad Request
```
{
  "type": "BAD_REQUEST",
  "message": "Bad request"
}
```

#### 401 Unauthorized
```
{
  "type": "UNAUTHORIZED",
  "message": "Invalid credentials"
}
```

#### 500 Internal Server Error
```
{
  "type": "INTERNAL_SERVER_ERROR",
  "message": "Internal server error"
}
```
